#define __OCICPP_INTERNAL_USE_
#include "BFile.h"


BFile::BFile() {
	init(0,0,0);
}

BFile::BFile(OCISvcCtx *svcctx,OCILobLocator *lob_desc,OCIError *err) {
	init(svcctx,lob_desc,err);
}

void BFile::init(OCISvcCtx *svcctx,OCILobLocator *lob_desc,OCIError *err) {
	boolean flg;
	svchp=svcctx;
	lob=lob_desc;
	errhp=err;
	offset=1;
	if(svchp && errhp) {
		DEBUG(DLEV_DEBUG,"Obtaining BFile len\n");
		CHECKERR(errhp,OCILobFileExists(svchp,errhp,lob,&flg));
		if(flg==FALSE) {
			throw OraError("OCICCPLIB: File not exist on server",OCICPPERROR);
		}
		CHECKERR(errhp,OCILobGetLength(svchp,errhp,lob,(ub4 *)&len));
		
		DEBUG(DLEV_DEBUG,"BFile len is %d\n",len);
	} else {
		len=0;
	}
}

BFile::~BFile() {
	/* nothing to be done yet 
	   all real work is in ~Cursor
	   See TODO about how it should work ..
	*/
	drop();
}

void BFile::drop() {
}
void BFile::seek(unsigned new_offset,int dir) {
	if((!len && new_offset>0) ||
	   ((dir==END ||dir==SET) && new_offset>len) ||
	   (dir==CUR && (new_offset+offset-1)>len)) {
		throw OraError("OCICPPLIB: Cannot seek: offset out of range",OCICPPERROR);
	}
	if(dir==SET) offset=new_offset+1;
	else if(dir==END) offset=len-new_offset+1;
	else if(dir==CUR) offset=offset+new_offset;
	else throw OraError("OCICPPLIB: Cannot seek: Unknown direction",OCICPPERROR);
}
unsigned BFile::tell() {
	return offset-1;
}

void BFile::open() {
	CHECKERR(errhp,OCILobFileOpen(svchp,errhp,lob,OCI_FILE_READONLY));
}

void BFile::close() {
	CHECKERR(errhp,OCILobFileClose(svchp,errhp,lob));
}

unsigned BFile::read(void * buf,int buf_len) {
	unsigned off;
	unsigned actread=buf_len;
	off=offset;
	CHECKERR(errhp,OCILobRead(svchp,errhp,lob,(ub4 *)&actread,(ub4)off,buf,(ub4)buf_len,0,
			   (sb4 (*)(dvoid *, const dvoid *, ub4, ub1)) 0,(ub2) 0, (ub1) SQLCS_IMPLICIT));
	offset+=actread;
	return actread;
}

unsigned BFile::getLen() const {
	return len;
}


	
		