#ifndef __BFILE_H_
#define __BFILE_H_

#include "ocicpp.h"
#include "OraError.h"

class BFile {
private:
	OCILobLocator *lob;
	OCIError *errhp;
	OCISvcCtx *svchp;
	int type; /* FILE */
	unsigned len; /* Overall length */
	unsigned offset; /* Current offset default 1 */
public:
	BFile();
	BFile(OCISvcCtx *svcctx,OCILobLocator *lob_desc,OCIError *err);
	void init(OCISvcCtx *svcctx,OCILobLocator *lob_desc,OCIError *err);
	~BFile();
	void drop();
	void seek(unsigned offset,int dir); /* Set's the current position
								 dir is SET or CUR or END
								 similair to stdc seek call 
							  */
	unsigned tell();
	void open();
	void close();
	
	unsigned read(void *buff,int blen); /* returns number of bytes or chracters actually read 
													if offset -1 use internal offset set by seek
												 */
	unsigned getLen() const;
	friend class Lob;
};	
	
#endif	