#ifndef __CONNECTION_H_
#define __CONNECTION_H_

#include "ocicpp.h"
#include "Cursor.h"

class Connection {
private:
	OCIEnv *envhp;
	OCIServer *srvhp;
	OCIError *errhp;
	OCISvcCtx *svchp;
	OCISession *authp;
	OCITrans *trans; /* Only one transaction allowed per connection */
	sword status;
	int Initialized;
public:
	Connection();
	Connection(OCIEnv *env,const string &tnsname,const string &user,const string &password);
	~Connection(); 
	void drop();
	void init(OCIEnv *env,const string &tnsname,const string &user,const string &password); 
	/* Obsolete should not be used. */
	Cursor *execQuery(const string &);
	/* Use this one... */
	void execQuery(const string &,Cursor &,int prefetch=1);
	void execUpdate(const string &);
	/* Transactions */
	void transStart(int flags=SERIALIZABLE);
	void transCommit();
	void transRollback();
	/* Advanced query execution mechanism */
	void prepare(const string &sql,Cursor &cur,int prefetch=1);
};





#endif