#ifndef __LOB_H_
#define __LOB_H_

#include "BFile.h"
#include "ocicpp.h"
#include "OraError.h"

class Lob {
private:
	OCILobLocator *lob;
	OCIError *errhp;
	OCISvcCtx *svchp;
	int type; /* CLOB or BLOB or FILE */
	unsigned len; /* Overall length */
	unsigned offset; /* Current offset default 1 */
	int cache; /* CACHE_ON or CACHE_OFF not supported yet */
public:
	Lob();
	Lob(OCISvcCtx *svcctx,OCILobLocator *lob_desc,OCIError *err,int type,int cache_mode);
	void init(OCISvcCtx *svcctx,OCILobLocator *lob_desc,OCIError *err,int type,int cache_mode);
	~Lob();
	void drop();
	void seek(unsigned offset,int dir); /* Set's the current position
								 dir is SET or CUR or END
								 similair to stdc seek call 
							  */
	unsigned tell();
	unsigned read(void *buff,int blen); /* returns number of bytes or chracters actually read */
	unsigned write(const void *buff,int blen);
	void trunc(unsigned); /* Truncate lob */
	void loadFromBFile(BFile &bfile,unsigned int amount,unsigned int dst_offset,unsigned int src_offset);
	void setCacheMode(int mode); /* mode is CACHE_ON or CACHE_OFF */
	unsigned getLen() const;
};	
	
#endif	