#define __OCICPP_INTERNAL_USE_
#include "OraBFile.h"


OraBFile::OraBFile(OCIEnv *envhp,OCIError *errhp,OCIParam *param,OCISvcCtx *svc,ub2 lob_type,int rows): 
				OraType(envhp,errhp,param,lob_type,rows),lob(0),svchp(svc)
{
	ReqType=lob_type;
	size=0;
	lob=(OCILobLocator **)calloc(nRows,sizeof(OCILobLocator *));
	for(int i=0;i<nRows;i++) {
		if(OCIDescriptorAlloc((void *)envhp,(void **)&lob[i],OCI_DTYPE_FILE,0,0)!=OCI_SUCCESS) {
				throw OraError("OCICPPLIB: Cannot make new LOB: Handle Allocation failed",OCICPPERROR);
		}
	}
}

OraBFile::~OraBFile() {

	for(int i=0;i<nRows;i++) {
		OCIDescriptorFree(lob[i],OCI_DTYPE_FILE);
	}
	free(lob);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);
}

void OraBFile::define(OCIStmt *stmt,int col) {
	 CHECKERR(err, OCIDefineByPos(stmt,&definehp, err, col+1, lob, -1,SQLT_FILE,
	                                (dvoid *) null, 0, (ub2 *)0, OCI_DEFAULT)); 
}

void OraBFile::getFILE(BFile &bfile,int row) {
	bfile.init(svchp,lob[row],err);
}

void OraBFile::getStr(string &str,int row) {
	str.assign(typeName);
}